/*	$Id: ipc.h,v 1.8 2005/08/24 21:15:48 phil Exp $ */

/* BLURB gpl

                           Coda File System
                              Release 6

          Copyright (c) 1987-2005 Carnegie Mellon University
                  Additional copyrights listed below

This  code  is  distributed "AS IS" without warranty of any kind under
the terms of the GNU General Public Licence Version 2, as shown in the
file  LICENSE.  The  technical and financial  contributors to Coda are
listed in the file CREDITS.

*/

#include <ntddk.h>

/* this file depends on coda.h */

// 210 secs (in units of 100ns) & 10 seconds
#define LONG_CODA_TIMEOUT 210L * 1000000L * 10L 
#define SHORT_CODA_TIMEOUT 10L * 1000000L * 10L

#define REQUEST_SIZE (sizeof(struct request))
#define USER_LEVEL_REQUEST_SIZE (REQUEST_SIZE  \
  - sizeof (struct req_list_entry) - 3*sizeof(ULONG))
#define DWORD ULONG

/* prototypes for rpc routines */
NTSTATUS request_init();
int request_process(struct request *);
int insert_upcall (struct request *);
struct request *request_get_pending (int);
struct request *request_find (long);
void request_signal(struct request *);
void *request_allocate_data(struct request *req, int size);
struct request *request_allocate (void);
void request_free (struct request *);
void request_free_data (struct request *);


#define WAIT_FOR_VENUS 0x13

/* upcall routines */
int coda_upcall(int insize,int *outsize, union inputArgs *inp);

#define REQUEST_BUF_SIZE sizeof(struct request) + 2 * (CFS_MAXNAMLEN + 4)

#pragma pack(push, 4)

struct request {
	struct dllist_head	le;		/* list threading pointers */
	KEVENT			*doneflag;	/* caller waits on this */
	int			req_state;	/* where in the process is the req? */
	DWORD			rh;		/* resource handle of this connection */
	int			age;		/* age of request -- used for timing out */
	DWORD			req_fetchlen;	/* size to be fetched  (<= bufflen) */
	DWORD			req_answerlen;	/* size of answer (<= bufflen) */
	DWORD			req_bufflen;	/* size of req_data */
	union {
		union inputArgs		*in;
		union outputArgs	*out;
	} req_data;
	/* more data may go here */
};
/* values of flags -- only one */
#define VM_QUEUED 0x0
#define VM_WRITE  0x1
#define VM_READ   0x2

#pragma pack(pop)
